;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================
    .data
      hInst   HMODULE 0
      hBrush  HBRUSH  0
      rc      RECT    <>
    .code
;==============================================================================

DlgProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL ps:PAINTSTRUCT

    SWITCH uMsg

      CASE WM_ERASEBKGND

        print "WM_ERASEBKGND",9
        print hex$(wParam),13,10

      CASE WM_INITDIALOG

        invoke CreateSolidBrush, 0ff00h
        mov hBrush, eax

        mov rc.right, 10
        mov rc.bottom, 10

      CASE WM_COMMAND

        SWITCH wParam

          CASE 1000

            add rc.left, 10
            add rc.top, 10
            add rc.right, 10
            add rc.bottom, 10

            invoke InvalidateRect, hwndDlg, addr rc, FALSE

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, 0

        ENDSW

      CASE WM_PAINT

        print "WM_PAINT",9
        invoke BeginPaint, hwndDlg, ADDR ps
        print hex$(ps.hdc),13,10
        invoke FillRect, ps.hdc, addr rc, hBrush
        invoke EndPaint, hwndDlg, ADDR ps

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, 0

    ENDSW

    xor eax, eax
    ret

DlgProc endp

;==============================================================================
start:
;==============================================================================

    invoke GetModuleHandle, NULL
    mov hInst, eax

    Dialog "Test", \
           "MS Sans Serif",8, \
           WS_OVERLAPPED or WS_SYSMENU or WS_MINIMIZEBOX or DS_CENTER, \
           1,0,0,150,160,1024

    DlgButton "OK",0,110,20,20,10,1000

    CallModalDialog hInst,0,DlgProc,NULL

    exit
;==============================================================================
end start